#ifndef EX94317DEMO_H
#define EX94317DEMO_H

#include <QMainWindow>
#include <QCloseEvent>
#include <QCheckBox>
#include <QComboBox>
#include <QMessageBox>

#include "public_parameter.h"
#include "timer_form.h"
#include "interrupt_form.h"

namespace Ui {
    class ex94317demo;
}

class ex94317demo : public QMainWindow
{
    Q_OBJECT

public:
    explicit ex94317demo(QWidget *parent = 0);
    ~ex94317demo();
    // sub fuction:
    void initial_card();
    void io_config_read();
    void io_rename(int,int);
    void io_point_read();



protected:
      void timerEvent ( QTimerEvent *event);
      void closeEvent ( QCloseEvent *event );
//  void showEvent ( QShowEvent * );
//  void paintEvent ( QPaintEvent *);


public:
      int close_timer;
      bool initial_failed;
      int main_timer;
      u8 config_data;


private slots:
      void on_Exit_pushButton_clicked();

      void on_Debounce0_comboBox_currentIndexChanged(int index);

      void on_Debounce1_comboBox_currentIndexChanged(int index);

      void on_Debounce2_comboBox_currentIndexChanged(int index);

      void on_Debounce3_comboBox_currentIndexChanged(int index);

      void on_Debounce4_comboBox_currentIndexChanged(int index);

      void on_Debounce5_comboBox_currentIndexChanged(int index);


      void on_IOConfig0_comboBox_currentIndexChanged(int index);

      void on_IOConfig1_comboBox_currentIndexChanged(int index);

      void on_IOConfig2_comboBox_currentIndexChanged(int index);

      void on_IOConfig3_comboBox_currentIndexChanged(int index);

      void on_IOConfig4_comboBox_currentIndexChanged(int index);

      void on_IOConfig5_comboBox_currentIndexChanged(int index);

      void on_Port00_checkBox_clicked(bool checked);
      void on_Port01_checkBox_clicked(bool checked);
      void on_Port02_checkBox_clicked(bool checked);
      void on_Port03_checkBox_clicked(bool checked);
      void on_Port04_checkBox_clicked(bool checked);
      void on_Port05_checkBox_clicked(bool checked);
      void on_Port06_checkBox_clicked(bool checked);
      void on_Port07_checkBox_clicked(bool checked);

      void on_Port10_checkBox_clicked(bool checked);
      void on_Port11_checkBox_clicked(bool checked);
      void on_Port12_checkBox_clicked(bool checked);
      void on_Port13_checkBox_clicked(bool checked);
      void on_Port14_checkBox_clicked(bool checked);
      void on_Port15_checkBox_clicked(bool checked);
      void on_Port16_checkBox_clicked(bool checked);
      void on_Port17_checkBox_clicked(bool checked);

      void on_Port20_checkBox_clicked(bool checked);
      void on_Port21_checkBox_clicked(bool checked);
      void on_Port22_checkBox_clicked(bool checked);
      void on_Port23_checkBox_clicked(bool checked);
      void on_Port24_checkBox_clicked(bool checked);
      void on_Port25_checkBox_clicked(bool checked);
      void on_Port26_checkBox_clicked(bool checked);
      void on_Port27_checkBox_clicked(bool checked);

      void on_Port30_checkBox_clicked(bool checked);
      void on_Port31_checkBox_clicked(bool checked);
      void on_Port32_checkBox_clicked(bool checked);
      void on_Port33_checkBox_clicked(bool checked);
      void on_Port34_checkBox_clicked(bool checked);
      void on_Port35_checkBox_clicked(bool checked);
      void on_Port36_checkBox_clicked(bool checked);
      void on_Port37_checkBox_clicked(bool checked);

      void on_Port40_checkBox_clicked(bool checked);
      void on_Port41_checkBox_clicked(bool checked);
      void on_Port42_checkBox_clicked(bool checked);
      void on_Port43_checkBox_clicked(bool checked);
      void on_Port44_checkBox_clicked(bool checked);
      void on_Port45_checkBox_clicked(bool checked);
      void on_Port46_checkBox_clicked(bool checked);
      void on_Port47_checkBox_clicked(bool checked);

      void on_Port50_checkBox_clicked(bool checked);
      void on_Port51_checkBox_clicked(bool checked);
      void on_Port52_checkBox_clicked(bool checked);
      void on_Port53_checkBox_clicked(bool checked);
      void on_Port54_checkBox_clicked(bool checked);
      void on_Port55_checkBox_clicked(bool checked);
      void on_Port56_checkBox_clicked(bool checked);
      void on_Port57_checkBox_clicked(bool checked);

      void on_actionExit_triggered();

      void on_actionInterrupt_triggered();

      void on_actionTimer_triggered();

private:
    Ui::ex94317demo *ui;        
    Timer_Form *form_Timer;
    Interrupt_Form *form_Interrupt;

    // Object array
    QCheckBox *Port_checkBox[6][8];

    QComboBox *Debounce_comboBox[6];
    QComboBox *IOConfig_comboBox[6];
};

#endif // EX94317DEMO_H
