#ifndef INTERRUPT_FORM_H
#define INTERRUPT_FORM_H

#include <QWidget>
#include <QCloseEvent>
#include <QCheckBox>

#include "public_parameter.h"

namespace Ui {
    class Interrupt_Form;
}

class Interrupt_Form : public QWidget
{
    Q_OBJECT

public:
    explicit Interrupt_Form(QWidget *parent = 0, Qt::WindowFlags fl = 0 );
    ~Interrupt_Form();
    // sub fuction:
    void mask_read();
    void status_read();
    void polarity_read();

public:
      int interrupt_timer;
      bool is_fomr_started;
      u8 irq_mask;
      u8 irq_polarity;


protected:
      void timerEvent ( QTimerEvent *event);
      void closeEvent ( QCloseEvent *event );
      void showEvent ( QShowEvent * );


private slots:
      void on_Mask00_checkBox_clicked(bool checked);
      void on_Mask01_checkBox_clicked(bool checked);
      void on_Mask02_checkBox_clicked(bool checked);
      void on_Mask03_checkBox_clicked(bool checked);
      void on_Mask04_checkBox_clicked(bool checked);
      void on_Mask05_checkBox_clicked(bool checked);
      void on_Mask06_checkBox_clicked(bool checked);
      void on_Mask07_checkBox_clicked(bool checked);
      void on_Polarity00_checkBox_clicked(bool checked);
      void on_Polarity01_checkBox_clicked(bool checked);
      void on_Polarity02_checkBox_clicked(bool checked);
      void on_Polarity03_checkBox_clicked(bool checked);
      void on_Polarity04_checkBox_clicked(bool checked);
      void on_Polarity05_checkBox_clicked(bool checked);
      void on_Polarity06_checkBox_clicked(bool checked);
      void on_Polarity07_checkBox_clicked(bool checked);

      void on_TCMask_checkBox_clicked(bool checked);

      void on_EnableIRQ_checkBox_clicked(bool checked);

private:
    Ui::Interrupt_Form *ui;
    // Object array
    QCheckBox *Mask_checkBox[8];
    QCheckBox *Status_checkBox[8];
    QCheckBox *Polarity_checkBox[8];
};

#endif // INTERRUPT_FORM_H
