#include "timer_form.h"
#include "ui_timer_form.h"


// ------------ constructor & destructor ---------------
Timer_Form::Timer_Form(QWidget *parent, Qt::WindowFlags fl ):
    QWidget(parent, fl),
    ui(new Ui::Timer_Form)
{
    ui->setupUi(this);
    this->is_fomr_started = false;
}

Timer_Form::~Timer_Form()
{
    delete ui;
}




// ------------ event ---------------
void Timer_Form::timerEvent ( QTimerEvent *event )
{
    double data = 0;
    // qWarning("test");
    if ( event->timerId() == this->Timer_timer )
    {
        this->timer_read();

        data = this->ui->ReloadValue_lineEdit->text().toDouble();
        data = (data+1.0) * 0.000001;
        this->ui->Timer_label->setText( "Timer = " + QString( "%1" ).arg ( data, 0, 'f', 6 ) + " (sec)" );


    }
}

void Timer_Form::closeEvent ( QCloseEvent *event )
{
    killTimer(this->Timer_timer);
    this->Timer_timer = 0;
    this->is_fomr_started = false;
    event->accept();
}

void Timer_Form::showEvent(QShowEvent *)
{
    qWarning("showEvent");

    u32 data = 0;

    if ( false == this->is_fomr_started )
    {
        Status = EX94317_TC_read( CardID, 1, &data );
        this->ui->CurrentCounter_label->setText( QString::number(data, 10) );
        this->ui->ReloadValue_lineEdit->setText( this->ui->CurrentCounter_label->text() );


        this->Timer_timer = startTimer(100);
        this->is_fomr_started = true;
    }
}




// ------------ sub-function ---------------
void Timer_Form::timer_read()
{
    u32 data = 0;
    Status = EX94317_TC_read( CardID, 2, &data );
    this->ui->CurrentCounter_label->setText( QString::number(data, 10) );
}




// ------------ slot ---------------
void Timer_Form::on_SetTimer_pushButton_clicked()
{
    double temp_value = this->ui->ReloadValue_lineEdit->text().toDouble();
    u32 value = 0;
    qWarning("temp_value = %d",temp_value);
    qWarning("sizeof( u32 ) = %lf", pow(2.0,32) );
    if ( temp_value >= pow(2.0,32) )
    {
        this->ui->ReloadValue_lineEdit->setText( QString( "%1" ).arg ( pow(2.0,32)-1, 0, 'f', 0 ) );
    }
    else if ( temp_value < 65535 )
    {
        this->ui->ReloadValue_lineEdit->setText( "65535" );
    }
    else
    {
    }

    value = this->ui->ReloadValue_lineEdit->text().toDouble();
    Status = EX94317_timer_set( CardID, value );
}

void Timer_Form::on_StartTimer_pushButton_clicked()
{
    double temp_value = this->ui->ReloadValue_lineEdit->text().toDouble();
    if ( temp_value >= 65535 )
    {
        Status = EX94317_timer_start( CardID );
    }
    else
    {
        switch( QMessageBox::warning( this, QString::fromUtf8 ("Warning"),
                                      QString::fromUtf8 ("Timer start failed, please set timer again"),
                                      QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton ) )
        {
            case QMessageBox::Ok: 		// first button in message box
            {
            }
            default:
            {
                break;
            }
        }
    }

}

void Timer_Form::on_StopTimer_pushButton_clicked()
{
    Status = EX94317_timer_stop( CardID );
}



