#ifndef _DLL_
#ifndef EXDRV_MAJOR
#define EXDRV_MAJOR 0

#ifndef EXDRV_MINOR
#define EXDRV_MINOR 0

#endif
#endif
#endif

#ifndef EX_MAXDEV
#define EX_MAXDEV 16
#endif


//#define	SUCCESS				1
#define		FAIL				0


////////////// Error Code ///////////////////////
#define		EXDRV_NO_ERROR			0
#define 	SUCCESS				0
#define 	INVALID_ADDRESS			-1
#define		INVALID_DATA			-2
#define		INVALID_CMD			-3
#define		INITIAL_FAIL			-100

/************ Bar0 Offset Address ************/
#define 	_PORT0  			0x0000	//Port0
#define		_PORT1				0x0002	//Port1
#define		_PORT2				0x0004	//Port2
#define		_PORT3				0x0006	//Port3
#define		_PORT4				0x0008	//Port4
#define		_PORT5				0x000A	//Port5

#define		_DEBOUNCE_TIME0			0x0010	//Debounce time for port0
#define		_DEBOUNCE_TIME1			0x0012	//Debounce time for port1
#define		_DEBOUNCE_TIME2			0x0014	//Debounce time for port2
#define		_DEBOUNCE_TIME3			0x0016	//Debounce time for port3
#define		_DEBOUNCE_TIME4			0x0018	//Debounce time for port4
#define		_DEBOUNCE_TIME5			0x001A	//Debounce time for port5

#define		_PIOCFG				0x0020	//Port IO configuration
#define		_CARD_ID			0x0022	//card ID register
#define		_IRQ_POLARITY			0x0024	//Port0 interrupt bit polarity
#define		_IRQ_MASK			0x0026	//Port0 interrupt bit mask
#define		_IRQ_STATUS			0x0028	//register of Interrupt request enable status

#define 	_OUT_PORT0  			0x0030	//OutPort0's register
#define		_OUT_PORT1			0x0032	//OutPort1's register
#define		_OUT_PORT2			0x0034	//OutPort2's register
#define		_OUT_PORT3			0x0036	//OutPort3's register
#define		_OUT_PORT4			0x0038	//OutPort4's register
#define		_OUT_PORT5			0x003A	//OutPort5's register

#define		_PCI_IRQ_ENABLE			0x0076	//PCI interrupt enable
#define		_I2C_OUT_B			0x0078	//security register



/************ Bar1 Offset Address ************/
#define 	_TC_CONTROL  			0x0020	//T/C software control register
#define 	_PRELOAD_L  			0x002C	//counter preload low word register
#define 	_PRELOAD_H  			0x002E	//counter preload high word register
#define 	_COUNTER_L  			0x0030	//counter low word register
#define 	_COUNTER_H  			0x0032	//counter hight word register
#define 	_TC_IRQ_MASK 			0x0060	//T/C interrupt request mask register
#define 	_TC_IRQ_STATUS			0x0062	//register of T/C interrupt request enable status


//////////////////////////////////////
#define 	_EXIOC_NONE			0U
#define		_EXIOC_WRITE			1U
#define		_EXIOC_READ			2U

#define		_EXIOC(dir,type,nr,size) \
		(((dir)  << _IOC_DIRSHIFT) | \
	 	((type) << _IOC_TYPESHIFT) | \
	 	((nr)   << _IOC_NRSHIFT) | \
		 ((size) << _IOC_SIZESHIFT))

/* used to create numbers */
#define		_EXIO(type,nr)			_EXIOC(_EXIOC_NONE,(type),(nr),0)
#define		_EXIOR(type,nr,size)		_EXIOC(_EXIOC_READ,(type),(nr),sizeof(size))
#define		_EXIOW(type,nr,size)		_EXIOC(_EXIOC_WRITE,(type),(nr),sizeof(size))
#define		_EXIOWR(type,nr,size)		_EXIOC(_EXIOC_READ|_EXIOC_WRITE,(type),(nr),sizeof(size))

/* Use 'j' as magic number to define EXIOctl functEXIOns*/
#define 	EXPCI_MAGIC			'j'
//#define JPCI_LINK         _PCIW(EXPCI_MAGIC, 10,    1)
#define		EXPCI_RBYTE			_EXIOR(EXPCI_MAGIC, 11,1) /* (TYPE,NR,SIZE) */
#define		EXPCI_WBYTE			_EXIOW(EXPCI_MAGIC, 12,1)
#define		EXPCI_RWORD			_EXIOR(EXPCI_MAGIC, 13,1)
#define		EXPCI_WWORD			_EXIOW(EXPCI_MAGIC, 14,1)
#define		EXPCI_RLONG			_EXIOR(EXPCI_MAGIC, 15,1)
#define		EXPCI_WLONG			_EXIOW(EXPCI_MAGIC, 16,1)
#define		EXPCI_RINDEX			_EXIOWR(EXPCI_MAGIC,17,1)
#define		EXPCI_WINDEX			_EXIOWR(EXPCI_MAGIC,18,1)
#define		EXPCI_FIND			_EXIOR(EXPCI_MAGIC,20,1)
#define		EXPCI_RESOURCE			_EXIOR(EXPCI_MAGIC,21,1)
#define		EXPCI_RBYTEREG			_EXIOR(EXPCI_MAGIC, 31,1) /* (TYPE,NR,SIZE) */
#define		EXPCI_WBYTEREG			_EXIOW(EXPCI_MAGIC, 32,1)
#define		EXPCI_RWORDREG			_EXIOR(EXPCI_MAGIC, 33,1)
#define		EXPCI_WWORDREG			_EXIOW(EXPCI_MAGIC, 34,1)
#define		EXPCI_RLONGREG			_EXIOR(EXPCI_MAGIC, 35,1)
#define		EXPCI_WLONGREG			_EXIOW(EXPCI_MAGIC, 36,1)
#define		EXPCI_HOOK_IRQ_SR		_EXIOW(EXPCI_MAGIC,41,1)
#define		EXPCI_UNHOOK_IRQ_SR		_EXIOW(EXPCI_MAGIC,42,1)
#define		EXPCI_IRQ_FLAG			_EXIOW(EXPCI_MAGIC,43,1)
#define		EXPCI_IRQ_CLEARFLAG		_EXIOW(EXPCI_MAGIC,44,1)
#define		EXPCI_IRQ_STATUS_READ		_EXIOW(EXPCI_MAGIC,45,1)


#ifndef _DLL_
static  int EX94317_init(void);
static void EX94317_exit(void);
static int find_94317(void);
static int EX94317_open(struct inode* , struct file* );
static int EX94317_release(struct inode *, struct file *);
static int EX94317_ioctl(struct inode *, struct file*, unsigned int, unsigned long);
static int EX94317_fasync(int fd, struct file *, int mode );




struct file_operations ex_fops=
  {
    .owner= THIS_MODULE,
    NULL,
    NULL,
    NULL,
    .ioctl= EX94317_ioctl,
    .open = EX94317_open,
    .release= EX94317_release,
    .fasync=  EX94317_fasync,
  };

#endif

#define I386       //mark this means OS for 64bit  

typedef  struct _pci_info
  {
    unsigned short vendor_id;
    unsigned short device_id;
    unsigned short subvendor_id;
    unsigned short subdevice_id;
    unsigned short address_offset0;
    unsigned short address_offset1;
    unsigned short register_offset;
  } pci_info;

//-------------------------------------//

typedef  struct _irq_data
  {
    unsigned short  irq_status_mask;
    unsigned short  irq_status;
#ifdef I386
    unsigned long  bridge_ei;
    unsigned long  bridge_di;
    unsigned long  reset_irq;
    unsigned long  initial_bridge;
#else 
    unsigned int  bridge_ei;
    unsigned int  bridge_di;
    unsigned int  reset_irq;
    unsigned int  initial_bridge;
#endif
  } irq_data;

//-------------------------------------//

typedef struct _irq_resource
  {
#ifdef I386
    unsigned long CardID;
    unsigned long base_address;
    unsigned long tc_address;
#else
    unsigned int CardID;
    unsigned int base_address;
    unsigned int tc_address;
#endif
    unsigned short irq_flag;
    unsigned short pci_enable;
    unsigned short irq_data;
    unsigned short irq_mask;
    unsigned short irq_tcdata;
    unsigned short irq_tcmask;
  } irq_resource;

//-------------------------------------//

typedef  struct _irq_block
  {
    unsigned char CardID;
    void (*fn)(unsigned char);

  } irq_block;

//-------------------------------------//

typedef union _io_data
  {
    unsigned char  b[4];//high byte is the msb
    unsigned short w[2];
#ifdef I386
    unsigned long l;
#else
    unsigned int  l;
#endif

  } io_data;

//-------------------------------------//

typedef  struct _card_resource
  {
#ifdef I386
    unsigned long CardID;
    unsigned long base_address; //card resource io base address
    unsigned long tc_address; //card resource memory base address
#else
    unsigned int CardID;
    unsigned int base_address; //card resource io base address
    unsigned int tc_address; //card resource memory base address
#endif
    int source;
    unsigned short in_offset;
    unsigned short out_offset;
    unsigned short index;
    io_data  in_iodata;
    io_data  out_iodata;
    unsigned short irq_flag;
    unsigned short irq_data;
    unsigned short irq_tcdata;
    void (*callbackfn)(unsigned char); //callback function (unsigned char is CardID)
  }  card_resource;


